=== docs/requirements.txt ===
parse_cmake
sphinx==7.1.2
docutils==0.18.1
jinja2==3.1.6
sphinx_rtd_theme==3.0.1
