=== debian/changelog ===
openmw (0.49.0-1build1) resolute; urgency=medium

  * Rebuild against latest unshield

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:25:23 -0500

openmw (0.49.0-1) unstable; urgency=medium

  * Team upload

  [Bret Curtis ]
  * Upstream release: OpenMW-0.49.0 (Closes: #1108767, #1075344, #1072443)
  * Update debian/control: libmygui-dev (>= 3.4.3)

  [ Bastian Germann ]
  * Build with lua on ppc64el and riscv64 (Closes: #1049382)

 -- Antoine Le Gonidec <vv221@debian.org>  Sat, 04 Oct 2025 11:15:43 +0200
